<?php

declare(strict_types=1);

namespace Dedi\SyliusContactPlugin\DependencyInjection;

use Symfony\Component\Config\Definition\Builder\TreeBuilder;
use Symfony\Component\Config\Definition\ConfigurationInterface;

final class Configuration implements ConfigurationInterface
{
    /**
     * {@inheritdoc}
     */
    public function getConfigTreeBuilder(): TreeBuilder
    {
        $treeBuilder = new TreeBuilder('dedi_sylius_contact_plugin');
        if (\method_exists($treeBuilder, 'getRootNode')) {
            $rootNode = $treeBuilder->getRootNode();
        } else {
            // BC layer for symfony/config 4.1 and older
            $rootNode = $treeBuilder->root('dedi_sylius_contact_plugin');
        }

        $rootNode
            ->children()
                ->booleanNode('invisible_captcha')->defaultFalse()->end()
                ->scalarNode('phone_pattern')->defaultValue('^(?:0|\(?\+33\)?\s?|0033\s?)[1-79](?:[\.\-\s]?\d\d){4}$')->end()
            ->end()
        ;

        return $treeBuilder;
    }
}
